package com.example.bump

import android.content.Context
import android.util.Log
import com.android.volley.Request
import com.android.volley.RequestQueue
import com.android.volley.toolbox.*
import com.maenle.bump.MainActivity

import org.json.JSONObject

class RestSingleton constructor(context: Context){

    init {
        MessageProcessor
    }
    companion object {
        @Volatile
        private var INSTANCE: RestSingleton? = null
        fun getInstance(context: Context) =
            INSTANCE ?: synchronized(this) {
                INSTANCE ?: RestSingleton(context).also {
                    INSTANCE = it
                }
            }

        private val TAG = MainActivity::class.java.simpleName
        private const val URL = "http://192.168.68.127:4000/api/"
    }

    fun peek(sender: String, callback: (String) -> Unit){
        val url = URL + "peek/"
        val data = JSONObject()
        data.put("sender", sender)
        val jsonRequest = JsonObjectRequest(Request.Method.POST, url,
            data,
            { response -> callback(response.toString()) },
            {callback("")})

        requestQueue.add(jsonRequest)
    }

    fun push(sender: String, message: String, function: () -> Unit){
        val url = URL + "push/"
        val data = JSONObject()
        data.put("sender", sender)
        data.put("data", message)
        val stringRequest = JsonObjectRequest(Request.Method.POST, url,
            data,
            {_ -> function()},
            {Log.d(TAG, "none")}
        )

        requestQueue.add(stringRequest)
    }

    fun pop(sender: String,callback: (String) -> Unit){
        val url = URL + "pop/"
        val data = JSONObject()
        data.put("sender", sender)
        val stringRequest = JsonObjectRequest(Request.Method.POST, url,
            data,
            { response -> callback(response.toString()) },
            {callback("")})

        requestQueue.add(stringRequest)
    }


    private val requestQueue: RequestQueue by lazy {
        // applicationContext is key, it keeps you from leaking the
        // Activity or BroadcastReceiver if someone passes one in.
        Volley.newRequestQueue(context.applicationContext)
    }
    fun <T> addToRequestQueue(req: Request<T>) {
        requestQueue.add(req)
    }
}